;ADDA-EEPROM.a51 *******  Analogwerte speichern, anschlieend wieder ausgeben *********************
;			Analogwert:	Eingabe: Poti 0 bis 5V an Ain0  
;					Ausgabe: Aout
;			Digitalwert: LEDs P2 
;*** Achtung: Nicht zu oft ausfhren, da Anzahl Schreibzyklen auf das EEPROM begrenzt (Lebensdauer)
;***************************************************************************************************


;********** Hilfsprogramme in ADDAhilf.a51 *********************************************************
		extern code Ain0,Aout
		
		code at 0
		include REG_8252.pdf	;Registeradressen AT89S8252
	
;	WMCON:	DATA	96h		;Bit4:	1 int EEPROM zum Schreiben freigeben
						;Bit3:	1 int EEPROM mit movx ansprechen
						;Bit1:	ist 0 wenn int.EEPROM-Schreibzyklus noch nicht beendet

		orl	WMCON,#00011000b	;int EEProm zum Schreiben freigeben
						;int. EEPROM durch movx ansprechen
		mov	dptr,#0		;Anfangsadresse EEPROM
	
loop:		lcall	Ain0			;Wert vom Analogeingang 0 holen
		movx	@dptr,a		;und im EEPROM ablegen	
waitEEProm:	mov	a,WMCON		;Zustand EEPROM-Schreibzyklus holen
		anl	a,#00000010b	;Bit1 maskieren (s.o.)
		jz	waitEEProm		;Sprung wenn int. EEPROM-Schreibzyklus noch nicht beendet
		movx	a,@dptr		;Wert aus EEPROM wieder abholen
		mov	p2,a			;und an LEDs
		lcall	Aout			;und Analogausgang ausgeben
		lcall	zeit
		sjmp	loop

;********* Zeitverzgerung **************************************************************************
		mov	r2,#10
zeit:		djnz	r0,zeit
		djnz	r1,zeit
		djnz	r2,zeit
		ret	
